# Commandes bash





#### history

```bash
# Synology

$ history
  502  cd `/usr/local/etc/apache24`
  503  cd /usr/local/etc/apache24
  504  cd conf
  505  nano httpd24.conf
  506  cd
  507  cd .ssh/
  508  chown http:http wp*
  509  sudo chown http:http wp*
  510  l
  511  cat wp_rsa
  512  sudo cat wp_rsa
  513  sudo cat id_rsa
  514  ssh-keygen -t rsa -b 1024
  515  l
  516  cat wp_rsa
  517  sudo cat wp_rsa
  518  l
  519  sudo rm wp*
  520  l
  521  history
```



#### Commandes:

```bash
$ history | grep 'chmod'
  250  sudo chmod -R 755 gallery/
  251  sudo chmod -R 644 gallery/
  252  sudo chmod -R 755 gallery/
  275  sudo chmod -R 755 public/
  358  chmod -R 755 public/
  359  sudo chmod -R 755 public/
  360  sudo chmod -R 755 public/
  361  sudo chmod -R 755 public/
  407  sudo chmod -R 755 gallery/
  408  sudo chmod -R 755 /volume1/web/gallery/
  526  history | grep 'chmod'
```

Excécuter une commande de l'historique d'après son nombre (!#):

```bash title="!507"
$ !507
cd .ssh/
drwx------    1 bruno    users          124 Mar 15 19:23 .
drwxr-xr-x    1 bruno    users          812 Mar 16 09:31 ..
-rw-------    1 bruno    users         5325 Mar 31  2020 _authorized_keys.bak
-rw-------    1 bruno    users         8200 Mar 11 14:30 authorized_keys
-rw-------    1 bruno    users         3326 Nov 19  2019 id_rsa
-rw-r--r--    1 bruno    users          734 Nov 19  2019 id_rsa.pub
-rw-r--r--    1 bruno    users          550 Mar 15 11:00 known_hosts
bruno@DS916:~/.ssh $
```

Excécuter 2 commandes en arrière:

```bash title="!-2"
$ !-2

# 10 commandes en arrière
$ !-10
```

Ré-excécuter la dernière commande (!!):

```bash title="!!"
$ cat .npmrc
#prefix=/var/services/homes/bruno/.npm-packages
tmp=/tmp

$ !!
cat .npmrc
#prefix=/var/services/homes/bruno/.npm-packages
tmp=/tmp

# !! est équivalent à !-1
```

Relancer la dernière commande avec sudo comme préfixe:

```bash title="sudo !!"
$ nano /etc/fstab

$ sudo !!
sudo nano /etc/fstab

```

Relancer la dernière commande avec 'keygen':

```bash title="!keygen"
$ !keygen
ssh-keygen -t rsa -b 1024
```

Rechercher la dernière commande avec 'keygen' sans l'exécuter:

```bash title="!keygen:p"
# on ajoute :p après

$ !keygen:p
ssh-keygen -t rsa -b 1024
```



```bash
# macOS

$ history
 5020* git clone https://github.com/thumbsup/theme-flow.git
 5021* l
 5024* cd Scripts/kymsu2/plugins.d
 5026* mas outdated --help
 5027* mas outdated help
 5028* mas --help
 5029* mas help
 5030* mas help outdated
 5031* mas help info
 5032* mas info 1243909868
 5033* ./mas.sh
 5034* mas outdated
 5035* mas info 784466108
 5036* mas info 1526844137
 5038  kymsu2
 5039* 916e
```

Grep:

```bash
$ history | grep mas
 5031* mas help info
 5032* mas info 1243909868
 5033* ./mas.sh
 5034* mas outdated
 5035* mas info 784466108
 5036* mas info 1526844137

```



#### Arguments:

